import React, { useRef, useState, useEffect } from 'react';
import ReactDOM from 'react-dom';

function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
function _arrayWithHoles(r) {
  if (Array.isArray(r)) return r;
}
function _arrayWithoutHoles(r) {
  if (Array.isArray(r)) return _arrayLikeToArray(r);
}
function asyncGeneratorStep(n, t, e, r, o, a, c) {
  try {
    var i = n[a](c),
      u = i.value;
  } catch (n) {
    return void e(n);
  }
  i.done ? t(u) : Promise.resolve(u).then(r, o);
}
function _asyncToGenerator(n) {
  return function () {
    var t = this,
      e = arguments;
    return new Promise(function (r, o) {
      var a = n.apply(t, e);
      function _next(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "next", n);
      }
      function _throw(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "throw", n);
      }
      _next(undefined);
    });
  };
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, {
    value: t,
    enumerable: true,
    configurable: true,
    writable: true
  }) : e[r] = t, e;
}
function _iterableToArray(r) {
  if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e,
      n,
      i,
      u,
      a = [],
      f = true,
      o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
    } catch (r) {
      o = true, n = r;
    } finally {
      try {
        if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function (r) {
      return Object.getOwnPropertyDescriptor(e, r).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), true).forEach(function (r) {
      _defineProperty(e, r, t[r]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) {
      Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
    });
  }
  return e;
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return e;
  };
  var t,
    e = {},
    r = Object.prototype,
    n = r.hasOwnProperty,
    o = Object.defineProperty || function (t, e, r) {
      t[e] = r.value;
    },
    i = "function" == typeof Symbol ? Symbol : {},
    a = i.iterator || "@@iterator",
    c = i.asyncIterator || "@@asyncIterator",
    u = i.toStringTag || "@@toStringTag";
  function define(t, e, r) {
    return Object.defineProperty(t, e, {
      value: r,
      enumerable: true,
      configurable: true,
      writable: true
    }), t[e];
  }
  try {
    define({}, "");
  } catch (t) {
    define = function (t, e, r) {
      return t[e] = r;
    };
  }
  function wrap(t, e, r, n) {
    var i = e && e.prototype instanceof Generator ? e : Generator,
      a = Object.create(i.prototype),
      c = new Context(n || []);
    return o(a, "_invoke", {
      value: makeInvokeMethod(t, r, c)
    }), a;
  }
  function tryCatch(t, e, r) {
    try {
      return {
        type: "normal",
        arg: t.call(e, r)
      };
    } catch (t) {
      return {
        type: "throw",
        arg: t
      };
    }
  }
  e.wrap = wrap;
  var h = "suspendedStart",
    l = "suspendedYield",
    f = "executing",
    s = "completed",
    y = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var p = {};
  define(p, a, function () {
    return this;
  });
  var d = Object.getPrototypeOf,
    v = d && d(d(values([])));
  v && v !== r && n.call(v, a) && (p = v);
  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
  function defineIteratorMethods(t) {
    ["next", "throw", "return"].forEach(function (e) {
      define(t, e, function (t) {
        return this._invoke(e, t);
      });
    });
  }
  function AsyncIterator(t, e) {
    function invoke(r, o, i, a) {
      var c = tryCatch(t[r], t, o);
      if ("throw" !== c.type) {
        var u = c.arg,
          h = u.value;
        return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
          invoke("next", t, i, a);
        }, function (t) {
          invoke("throw", t, i, a);
        }) : e.resolve(h).then(function (t) {
          u.value = t, i(u);
        }, function (t) {
          return invoke("throw", t, i, a);
        });
      }
      a(c.arg);
    }
    var r;
    o(this, "_invoke", {
      value: function (t, n) {
        function callInvokeWithMethodAndArg() {
          return new e(function (e, r) {
            invoke(t, n, e, r);
          });
        }
        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(e, r, n) {
    var o = h;
    return function (i, a) {
      if (o === f) throw Error("Generator is already running");
      if (o === s) {
        if ("throw" === i) throw a;
        return {
          value: t,
          done: true
        };
      }
      for (n.method = i, n.arg = a;;) {
        var c = n.delegate;
        if (c) {
          var u = maybeInvokeDelegate(c, n);
          if (u) {
            if (u === y) continue;
            return u;
          }
        }
        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
          if (o === h) throw o = s, n.arg;
          n.dispatchException(n.arg);
        } else "return" === n.method && n.abrupt("return", n.arg);
        o = f;
        var p = tryCatch(e, r, n);
        if ("normal" === p.type) {
          if (o = n.done ? s : l, p.arg === y) continue;
          return {
            value: p.arg,
            done: n.done
          };
        }
        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
      }
    };
  }
  function maybeInvokeDelegate(e, r) {
    var n = r.method,
      o = e.iterator[n];
    if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
    var i = tryCatch(o, e.iterator, r.arg);
    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
    var a = i.arg;
    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
  }
  function pushTryEntry(t) {
    var e = {
      tryLoc: t[0]
    };
    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
  }
  function resetTryEntry(t) {
    var e = t.completion || {};
    e.type = "normal", delete e.arg, t.completion = e;
  }
  function Context(t) {
    this.tryEntries = [{
      tryLoc: "root"
    }], t.forEach(pushTryEntry, this), this.reset(true);
  }
  function values(e) {
    if (e || "" === e) {
      var r = e[a];
      if (r) return r.call(e);
      if ("function" == typeof e.next) return e;
      if (!isNaN(e.length)) {
        var o = -1,
          i = function next() {
            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = false, next;
            return next.value = t, next.done = true, next;
          };
        return i.next = i;
      }
    }
    throw new TypeError(typeof e + " is not iterable");
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: true
  }), o(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: true
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
    var e = "function" == typeof t && t.constructor;
    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
  }, e.mark = function (t) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
  }, e.awrap = function (t) {
    return {
      __await: t
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
    return this;
  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
    undefined === i && (i = Promise);
    var a = new AsyncIterator(wrap(t, r, n, o), i);
    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
      return t.done ? t.value : a.next();
    });
  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
    return this;
  }), define(g, "toString", function () {
    return "[object Generator]";
  }), e.keys = function (t) {
    var e = Object(t),
      r = [];
    for (var n in e) r.push(n);
    return r.reverse(), function next() {
      for (; r.length;) {
        var t = r.pop();
        if (t in e) return next.value = t, next.done = false, next;
      }
      return next.done = true, next;
    };
  }, e.values = values, Context.prototype = {
    constructor: Context,
    reset: function (e) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = false, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
    },
    stop: function () {
      this.done = true;
      var t = this.tryEntries[0].completion;
      if ("throw" === t.type) throw t.arg;
      return this.rval;
    },
    dispatchException: function (e) {
      if (this.done) throw e;
      var r = this;
      function handle(n, o) {
        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
      }
      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
        var i = this.tryEntries[o],
          a = i.completion;
        if ("root" === i.tryLoc) return handle("end");
        if (i.tryLoc <= this.prev) {
          var c = n.call(i, "catchLoc"),
            u = n.call(i, "finallyLoc");
          if (c && u) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, true);
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          } else if (c) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, true);
          } else {
            if (!u) throw Error("try statement without catch or finally");
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          }
        }
      }
    },
    abrupt: function (t, e) {
      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
        var o = this.tryEntries[r];
        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
          var i = o;
          break;
        }
      }
      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
      var a = i ? i.completion : {};
      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
    },
    complete: function (t, e) {
      if ("throw" === t.type) throw t.arg;
      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
    },
    finish: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
      }
    },
    catch: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.tryLoc === t) {
          var n = r.completion;
          if ("throw" === n.type) {
            var o = n.arg;
            resetTryEntry(r);
          }
          return o;
        }
      }
      throw Error("illegal catch attempt");
    },
    delegateYield: function (e, r, n) {
      return this.delegate = {
        iterator: values(e),
        resultName: r,
        nextLoc: n
      }, "next" === this.method && (this.arg = t), y;
    }
  }, e;
}
function _slicedToArray(r, e) {
  return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest();
}
function _toConsumableArray(r) {
  return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread();
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (undefined !== e) {
    var i = e.call(t, r || "default");
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : undefined;
  }
}

var CloseIcon = function CloseIcon(_ref) {
  var className = _ref.className;
  return /*#__PURE__*/React.createElement("svg", {
    className: className,
    "aria-hidden": "true",
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 14 14"
  }, /*#__PURE__*/React.createElement("path", {
    stroke: "currentColor",
    strokeLinecap: "round",
    strokeLinejoin: "round",
    strokeWidth: "2",
    d: "m1 1 6 6m0 0 6 6M7 7l6-6M7 7l-6 6"
  }));
};

var validateFile = function validateFile(file, existingFiles) {
  var existingFilesList = existingFiles !== null && existingFiles !== undefined ? existingFiles : [];
  // Check for duplicates
  if (existingFilesList.some(function (existingFile) {
    return existingFile.name === file.name;
  })) {
    return "File already uploaded. Please upload another file";
  }
  var allowedTypes = ["image/jpeg", "image/png", "video/mp4", "video/webm", "video/quicktime"];
  if (!allowedTypes.includes(file.type)) {
    return "File type not supported. Please upload an image or video.";
  }
  return null;
};
var handleFileUpload = function handleFileUpload(event, uploadedFiles, setUploadedFiles, setErrors, uploadedFilesTitleRef) {
  var files = Array.from(event.target.files);
  var newFiles = [];
  var newErrors = {};
  var totalSize = uploadedFiles.reduce(function (sum, file) {
    return sum + file.size;
  }, 0);
  var hasDuplicateError = false;
  files.forEach(function (file) {
    var error = validateFile(file, uploadedFiles);
    if (error) {
      if (error === "File already uploaded. Please upload another file") {
        hasDuplicateError = true; // Flag duplicate error
      } else {
        newErrors[file.name] = error;
      }
    } else {
      newFiles.push(file);
      totalSize += file.size;
    }
  });

  // If there were duplicates, add only a single error message
  if (hasDuplicateError) {
    newErrors.duplicate = "One or more files already uploaded and were skipped";
  }

  // Check total size after processing all files
  if (totalSize > 15 * 1024 * 1024) {
    newErrors.totalSize = "Total file size across all uploaded files exceeds 15MB limit";
    newFiles = []; // Don't upload any files if total size exceeds limit
  }

  // Set errors if any exist
  if (Object.keys(newErrors).length > 0) {
    setErrors(function (prev) {
      return _objectSpread2(_objectSpread2({}, prev), {}, {
        files: newErrors
      });
    });
  } else {
    setErrors(function (prev) {
      return _objectSpread2(_objectSpread2({}, prev), {}, {
        files: null
      });
    });
  }

  // Upload valid files even if there are errors with some files
  if (newFiles.length > 0) {
    setUploadedFiles(function (prev) {
      return [].concat(_toConsumableArray(prev), _toConsumableArray(newFiles));
    });
  }
  setTimeout(function () {
    if (uploadedFilesTitleRef.current) {
      uploadedFilesTitleRef.current.scrollIntoView({
        behavior: "smooth"
      });
    }
  }, 100);
  event.target.value = "";
};
var handleChange = function handleChange(event, setFormData, setErrors) {
  var _event$target = event.target,
    id = _event$target.id,
    value = _event$target.value;
  setFormData(function (prev) {
    return _objectSpread2(_objectSpread2({}, prev), {}, _defineProperty({}, id, value));
  });
  setErrors(function (prev) {
    var newErrors = _objectSpread2({}, prev);

    // Clear existing error for this field
    delete newErrors[id];

    // Check character limits
    if (id === 'summary' && value.length > 255) {
      newErrors[id] = "Summary cannot exceed 255 characters";
    }
    if (id === 'details' && value.length > 10000) {
      newErrors[id] = "Details cannot exceed 10000 characters";
    }
    return newErrors;
  });
};
var removeFile = function removeFile(index, setUploadedFiles) {
  setUploadedFiles(function (prev) {
    return prev.filter(function (_, i) {
      return i !== index;
    });
  });
};
var resetForm = function resetForm(setFormData, setUploadedFiles, setErrors, setUnexpectedError) {
  setFormData({
    feedbackType: "",
    summary: "",
    details: ""
  });
  setUploadedFiles([]);
  setErrors({});
  setUnexpectedError("");
};

var LOCATION_API = "https://get.geojs.io/v1/ip/geo.json";

var TextInput = function TextInput(_ref) {
  var id = _ref.id,
    label = _ref.label,
    value = _ref.value,
    onChange = _ref.onChange,
    error = _ref.error,
    maxLength = _ref.maxLength;
  var isOverLimit = maxLength && value.length > maxLength;
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", {
    htmlFor: id,
    className: "support-tw-block support-tw-mb-2 support-tw-text-sm support-tw-font-bold support-tw-text-gray-900"
  }, label, " ", /*#__PURE__*/React.createElement("span", {
    className: "support-tw-text-red-500"
  }, "*")), /*#__PURE__*/React.createElement("input", {
    type: "text",
    id: id,
    value: value,
    onChange: onChange,
    className: "support-tw-border ".concat(error || isOverLimit ? "support-tw-border-red-500" : "support-tw-border-gray-400", " support-tw-text-gray-900 support-tw-text-sm support-tw-rounded-sm focus:support-tw-ring-primary focus:support-tw-border-gray-400 focus:support-tw-bg-gray-50 support-tw-outline-none support-tw-block support-tw-w-full support-tw-px-2.5 support-tw-py-2"),
    placeholder: label
  }), error ? /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-red-600 support-tw-text-small support-tw-mt-2"
  }, error) : maxLength && /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-gray-500 support-tw-text-xs support-tw-mt-1"
  }, value.length, "/", maxLength, " characters"));
};

var TextArea = function TextArea(_ref) {
  var id = _ref.id,
    label = _ref.label,
    value = _ref.value,
    onChange = _ref.onChange,
    error = _ref.error,
    maxLength = _ref.maxLength;
  var isOverLimit = maxLength && value.length > maxLength;
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", {
    htmlFor: id,
    className: "support-tw-block support-tw-mb-2 support-tw-text-sm support-tw-font-bold support-tw-text-gray-900"
  }, label, " ", /*#__PURE__*/React.createElement("span", {
    className: "support-tw-text-red-500"
  }, "*")), /*#__PURE__*/React.createElement("textarea", {
    id: id,
    value: value,
    onChange: onChange,
    rows: "3",
    className: "support-tw-block support-tw-px-2.5 support-tw-p-2 support-tw-w-full support-tw-text-sm support-tw-text-gray-900 support-tw-rounded-sm support-tw-border ".concat(error || isOverLimit ? "support-tw-border-red-500" : "support-tw-border-gray-400", " focus:support-tw-ring-primary focus:support-tw-border-gray-400 focus:support-tw-bg-gray-50 support-tw-outline-none"),
    placeholder: "Give us specifics to help resolve it quickly"
  }), error ? /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-red-600 support-tw-text-small support-tw-mt-2"
  }, error) : maxLength && /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-gray-500 support-tw-text-xs support-tw-mt-1"
  }, value.length, "/", maxLength, " characters"));
};

var FileUpload = function FileUpload(_ref) {
  var uploadedFiles = _ref.uploadedFiles,
    handleFileUpload = _ref.handleFileUpload,
    errors = _ref.errors,
    uploadedFilesTitleRef = _ref.uploadedFilesTitleRef,
    setUploadedFiles = _ref.setUploadedFiles;
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", {
    htmlFor: "attachment",
    className: "support-tw-block support-tw-mb-2 support-tw-text-sm support-tw-font-bold support-tw-text-gray-900"
  }, "Upload Screenshots or Videos (Optional)"), /*#__PURE__*/React.createElement("div", {
    className: "support-tw-flex support-tw-items-center support-tw-justify-center support-tw-w-full"
  }, /*#__PURE__*/React.createElement("label", {
    htmlFor: "attachment",
    className: "support-tw-relative support-tw-flex support-tw-flex-col support-tw-items-center support-tw-justify-center support-tw-w-full support-tw-border support-tw-border-gray-300 support-tw-rounded-sm support-tw-cursor-pointer support-tw-bg-lightGray support-tw-hover:bg-gray-100"
  }, /*#__PURE__*/React.createElement("div", {
    className: "support-tw-flex support-tw-flex-col support-tw-items-center support-tw-justify-center support-tw-py-4"
  }, /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-sm support-tw-text-gray-500 support-tw-text-center"
  }, "Drag and drop / Click to upload +")), /*#__PURE__*/React.createElement("input", {
    id: "attachment",
    type: "file",
    className: "support-tw-opacity-0 support-tw-absolute support-tw-w-full support-tw-h-full",
    accept: "image/jpeg, image/png, video/mp4, video/webm, video/quicktime",
    onChange: handleFileUpload,
    multiple: true
  }))), /*#__PURE__*/React.createElement("span", {
    className: "support-tw-text-xxs support-tw-italic support-tw-text-black",
    ref: uploadedFilesTitleRef
  }, "Format: jpg, png, mp4, mov, webm. Total Files Size: 15MB"), errors && Object.keys(errors).length > 0 && /*#__PURE__*/React.createElement("div", null, Object.values(errors).map(function (error, index) {
    return /*#__PURE__*/React.createElement("p", {
      key: index,
      className: "support-tw-text-red-600 support-tw-text-small support-tw-mt-2"
    }, error);
  })), uploadedFiles && uploadedFiles.length > 0 && /*#__PURE__*/React.createElement("div", {
    className: "support-tw-flex support-tw-flex-col"
  }, /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-sm support-tw-font-bold support-tw-mt-3 support-tw-text-small support-tw-text-black"
  }, "Uploaded Files (", uploadedFiles.length, ")"), uploadedFiles.map(function (file, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: index,
      className: "support-tw-flex support-tw-items-center support-tw-justify-between support-tw-bg-lightGray support-tw-border support-tw-border-lighterGray support-tw-px-4 support-tw-py-2 support-tw-rounded-sm support-tw-mt-2"
    }, /*#__PURE__*/React.createElement("span", {
      className: "support-tw-text-gray-600 support-tw-break-all support-tw-text-small"
    }, file.name), /*#__PURE__*/React.createElement("button", {
      type: "button",
      onClick: function onClick() {
        return removeFile(index, setUploadedFiles);
      },
      className: "support-tw-ml-3 support-tw-text-gray-400 hover:support-tw-text-red-600 support-tw-cursor-pointer"
    }, /*#__PURE__*/React.createElement(CloseIcon, {
      className: "support-tw-w-2.5 support-tw-h-2.5"
    })));
  })));
};

var DownArrow = function DownArrow(_ref) {
  var className = _ref.className;
  return /*#__PURE__*/React.createElement("svg", {
    className: className,
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    stroke: "currentColor"
  }, /*#__PURE__*/React.createElement("path", {
    strokeLinecap: "round",
    strokeLinejoin: "round",
    strokeWidth: "2",
    d: "M19 9l-7 7-7-7"
  }));
};

var SelectInput = function SelectInput(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    error = _ref.error;
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", {
    htmlFor: "feedbackType",
    className: "support-tw-block support-tw-mb-2 support-tw-text-sm support-tw-font-bold support-tw-text-gray-900"
  }, "Select Feedback Type ", /*#__PURE__*/React.createElement("span", {
    className: "support-tw-text-red-500"
  }, "*")), /*#__PURE__*/React.createElement("div", {
    className: "support-tw-relative support-tw-w-full"
  }, /*#__PURE__*/React.createElement("select", {
    id: "feedbackType",
    value: value,
    onChange: onChange,
    className: "support-tw-appearance-none support-tw-border ".concat(error ? "support-tw-border-red-500" : "support-tw-border-gray-400", " support-tw-text-gray-900 support-tw-text-sm support-tw-rounded-sm support-tw-outline-none support-tw-block support-tw-w-full support-tw-px-2.5 support-tw-py-2")
  }, /*#__PURE__*/React.createElement("option", null, "Select feedback type"), /*#__PURE__*/React.createElement("option", {
    value: "support"
  }, "Support"), /*#__PURE__*/React.createElement("option", {
    value: "idea"
  }, "Idea")), /*#__PURE__*/React.createElement("div", {
    className: "support-tw-pointer-events-none support-tw-absolute support-tw-inset-y-0 support-tw-right-0 support-tw-flex support-tw-items-center support-tw-pr-3"
  }, /*#__PURE__*/React.createElement(DownArrow, {
    className: "support-tw-w-4 support-tw-h-4 support-tw-text-gray-400"
  }))), error && /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-red-600 support-tw-text-small support-tw-mt-2"
  }, error));
};

var ThankyouIcon = function ThankyouIcon(_ref) {
  var className = _ref.className;
  return /*#__PURE__*/React.createElement("svg", {
    className: className,
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 88 117",
    fill: "currentColor"
  }, /*#__PURE__*/React.createElement("g", {
    fill: "none",
    fillRule: "evenodd",
    className: "support-tw-stroke-primary",
    strokeLinecap: "round",
    strokeLinejoin: "round",
    strokeWidth: "7.5"
  }, /*#__PURE__*/React.createElement("path", {
    d: "M77.778 111.735 48.01 90.087a7.23 7.23 0 0 0-8.502 0L9.74 111.735A3.614 3.614 0 0 1 4 108.819V11.23A7.23 7.23 0 0 1 11.229 4h65.06a7.23 7.23 0 0 1 7.23 7.229v97.59a3.614 3.614 0 0 1-5.74 2.916z"
  }), /*#__PURE__*/React.createElement("path", {
    d: "M65.446 38.029 39.084 64.386a3.61 3.61 0 0 1-5.108 0l-8.29-8.285"
  })));
};

var SuccessPopup = function SuccessPopup(_ref) {
  var onClose = _ref.onClose;
  return /*#__PURE__*/React.createElement("div", {
    className: "ik-support"
  }, /*#__PURE__*/React.createElement("div", {
    className: "support-tw-w-full support-tw-z-10 support-tw-fixed support-tw-inset-0 support-tw-justify-center support-tw-items-center support-tw-bg-overlay support-tw-flex"
  }, /*#__PURE__*/React.createElement("div", {
    className: "support-tw-relative support-tw-max-w-72 support-tw-min-w-72 support-tw-bg-white support-tw-rounded-md support-tw-flex support-tw-flex-col support-tw-items-center support-tw-justify-center support-tw-p-4 md:support-tw-p-7 support-tw-shadow-sm"
  }, /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "support-tw-absolute support-tw-top-2 support-tw-right-2 support-tw-text-gray-400 support-tw-bg-transparent hover:support-tw-bg-gray-200 hover:support-tw-text-gray-900 support-tw-rounded-full support-tw-text-sm support-tw-w-6 support-tw-h-6 support-tw-inline-flex support-tw-justify-center support-tw-items-center",
    onClick: onClose
  }, /*#__PURE__*/React.createElement(CloseIcon, {
    className: "support-tw-w-2.5 support-tw-h-2.5 support-tw-text-[#212b37]"
  }), /*#__PURE__*/React.createElement("span", {
    className: "support-tw-sr-only"
  }, "Close modal")), /*#__PURE__*/React.createElement(ThankyouIcon, {
    className: "support-tw-w-12 support-tw-pt-8"
  }), /*#__PURE__*/React.createElement("h1", {
    className: "support-tw-text-2xl support-tw-font-bold support-tw-text-gray-900 support-tw-text-center support-tw-pt-8"
  }, "Thank you!"), /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-md support-tw-pt-3 support-tw-text-gray-900 support-tw-px-5 support-tw-text-center"
  }, "You'll hear back from us shortly."))));
};

var uploadFileToS3 = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
    var _file$type;
    var uploadURL, file, response;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          uploadURL = _ref.uploadURL, file = _ref.file;
          if (file) {
            _context.next = 3;
            break;
          }
          throw new Error("No file provided");
        case 3:
          _context.next = 5;
          return fetch(uploadURL, {
            method: "PUT",
            headers: {
              "Content-Type": (_file$type = file.type) !== null && _file$type !== undefined ? _file$type : "multipart/form-data"
            },
            body: file
          });
        case 5:
          response = _context.sent;
          if (response.ok) {
            _context.next = 8;
            break;
          }
          throw new Error("Failed to upload file: ".concat(response.statusText));
        case 8:
          return _context.abrupt("return", response);
        case 9:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function uploadFileToS3(_x) {
    return _ref2.apply(this, arguments);
  };
}();
var uploadFiles = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(uploadedFiles, presignedResponse, setUnexpectedError) {
    var mediaLinks, hasUploadError;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          mediaLinks = [];
          hasUploadError = false;
          _context3.next = 4;
          return Promise.all(uploadedFiles.map(/*#__PURE__*/function () {
            var _ref4 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(file, index) {
              var attachmentKey, signedUrlObj, presignedUrl, uploadedFile, cleanFileUrl, fileNameWithExtension, fileName, fileExtension;
              return _regeneratorRuntime().wrap(function _callee2$(_context2) {
                while (1) switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.prev = 0;
                    attachmentKey = "attachment".concat(index + 1);
                    signedUrlObj = presignedResponse.s3_upload_destination.find(function (attachmentObj) {
                      return attachmentObj[attachmentKey];
                    });
                    presignedUrl = signedUrlObj ? signedUrlObj[attachmentKey] : null;
                    if (presignedUrl) {
                      _context2.next = 7;
                      break;
                    }
                    hasUploadError = true;
                    throw new Error("Signed URL for ".concat(attachmentKey, " not found."));
                  case 7:
                    _context2.next = 9;
                    return uploadFileToS3({
                      uploadURL: presignedUrl,
                      file: file
                    });
                  case 9:
                    uploadedFile = _context2.sent;
                    if (!(!uploadedFile || !uploadedFile.ok)) {
                      _context2.next = 13;
                      break;
                    }
                    hasUploadError = true;
                    throw new Error("Failed to upload file: ".concat(file.name));
                  case 13:
                    cleanFileUrl = uploadedFile.url.split("?")[0];
                    fileNameWithExtension = file.name;
                    fileName = file.name.split('.').slice(0, -1).join('.');
                    fileExtension = fileNameWithExtension.split('.').pop();
                    mediaLinks.push({
                      url: cleanFileUrl,
                      file_name: fileName,
                      ext: fileExtension
                    });
                    _context2.next = 25;
                    break;
                  case 20:
                    _context2.prev = 20;
                    _context2.t0 = _context2["catch"](0);
                    hasUploadError = true;
                    console.error("Error uploading file ".concat(file.name, ":"), _context2.t0.message);
                    setUnexpectedError("We couldn't create your ticket. Please try again later or contact operations@interviewkickstart.com for help.");
                  case 25:
                  case "end":
                    return _context2.stop();
                }
              }, _callee2, null, [[0, 20]]);
            }));
            return function (_x5, _x6) {
              return _ref4.apply(this, arguments);
            };
          }()));
        case 4:
          if (!hasUploadError) {
            _context3.next = 6;
            break;
          }
          throw new Error("File upload failed");
        case 6:
          return _context3.abrupt("return", mediaLinks);
        case 7:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return function uploadFiles(_x2, _x3, _x4) {
    return _ref3.apply(this, arguments);
  };
}();
var getPresignedURL = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(createAttachmentsPayload, uploadedFiles, uploadAttachmentsAPI, token) {
    var attachments, response;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          _context4.next = 2;
          return createAttachmentsPayload(uploadedFiles);
        case 2:
          attachments = _context4.sent;
          _context4.next = 5;
          return fetch(uploadAttachmentsAPI, {
            method: "POST",
            headers: {
              "Content-Type": "application/json",
              "X-CSRFToken": token
            },
            body: JSON.stringify(attachments)
          });
        case 5:
          response = _context4.sent;
          if (response.ok) {
            _context4.next = 8;
            break;
          }
          throw new Error("Failed to get presigned URL: ".concat(response.statusText));
        case 8:
          _context4.next = 10;
          return response.json();
        case 10:
          return _context4.abrupt("return", _context4.sent);
        case 11:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function getPresignedURL(_x7, _x8, _x9, _x10) {
    return _ref5.apply(this, arguments);
  };
}();
var getLocationData = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5(locationAPI) {
    var response;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          _context5.prev = 0;
          _context5.next = 3;
          return fetch(locationAPI);
        case 3:
          response = _context5.sent;
          if (response.ok) {
            _context5.next = 6;
            break;
          }
          throw new Error("Failed to get location: ".concat(response.statusText));
        case 6:
          _context5.next = 8;
          return response.json();
        case 8:
          return _context5.abrupt("return", _context5.sent);
        case 11:
          _context5.prev = 11;
          _context5.t0 = _context5["catch"](0);
          console.error("Error fetching location data:", _context5.t0);
          // Return null if the location data is not found
          return _context5.abrupt("return", null);
        case 15:
        case "end":
          return _context5.stop();
      }
    }, _callee5, null, [[0, 11]]);
  }));
  return function getLocationData(_x11) {
    return _ref6.apply(this, arguments);
  };
}();
var submitFeedback = /*#__PURE__*/function () {
  var _ref7 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee6(feedbackPayload, feedbackAPI, token) {
    var feedbackAPIResponse;
    return _regeneratorRuntime().wrap(function _callee6$(_context6) {
      while (1) switch (_context6.prev = _context6.next) {
        case 0:
          _context6.next = 2;
          return fetch(feedbackAPI, {
            method: "POST",
            headers: {
              "Content-Type": "application/json",
              "X-CSRFToken": token
            },
            body: JSON.stringify(feedbackPayload)
          });
        case 2:
          feedbackAPIResponse = _context6.sent;
          if (feedbackAPIResponse.ok) {
            _context6.next = 5;
            break;
          }
          throw new Error("Failed to submit feedback: ".concat(feedbackAPIResponse.statusText, "(status: ").concat(feedbackAPIResponse.status, ")"));
        case 5:
          return _context6.abrupt("return", feedbackAPIResponse);
        case 6:
        case "end":
          return _context6.stop();
      }
    }, _callee6);
  }));
  return function submitFeedback(_x12, _x13, _x14) {
    return _ref7.apply(this, arguments);
  };
}();

function getBrowserInfo() {
  if (navigator.userAgentData) {
    // For modern browsers with userAgentData
    var brands = navigator.userAgentData.brands;
    var browser = brands.map(function (brand) {
      return brand.brand;
    }).join(", ");
    var version = brands.map(function (brand) {
      return brand.version;
    }).join(", ");
    return {
      browser: browser,
      version: version
    };
  } else {
    // Fallback for older browsers using userAgent
    var userAgent = navigator.userAgent;
    var _browser = "Unknown Browser";
    var _version = "Unknown Version";
    if (userAgent.includes("Chrome") && !userAgent.includes("Edg")) {
      var _userAgent$match;
      _browser = "Google Chrome";
      _version = ((_userAgent$match = userAgent.match(/Chrome\/([\d.]+)/)) === null || _userAgent$match === undefined ? undefined : _userAgent$match[1]) || "Unknown";
    } else if (userAgent.includes("Firefox")) {
      var _userAgent$match2;
      _browser = "Mozilla Firefox";
      _version = ((_userAgent$match2 = userAgent.match(/Firefox\/([\d.]+)/)) === null || _userAgent$match2 === undefined ? undefined : _userAgent$match2[1]) || "Unknown";
    } else if (userAgent.includes("Safari") && !userAgent.includes("Chrome")) {
      var _userAgent$match3;
      _browser = "Apple Safari";
      _version = ((_userAgent$match3 = userAgent.match(/Version\/([\d.]+)/)) === null || _userAgent$match3 === undefined ? undefined : _userAgent$match3[1]) || "Unknown";
    } else if (userAgent.includes("Edg")) {
      var _userAgent$match4;
      _browser = "Microsoft Edge";
      _version = ((_userAgent$match4 = userAgent.match(/Edg\/([\d.]+)/)) === null || _userAgent$match4 === undefined ? undefined : _userAgent$match4[1]) || "Unknown";
    } else if (userAgent.includes("MSIE") || userAgent.includes("Trident")) {
      var _userAgent$match5;
      _browser = "Internet Explorer";
      _version = ((_userAgent$match5 = userAgent.match(/(MSIE [\d.]+|rv:[\d.]+)/)) === null || _userAgent$match5 === undefined ? undefined : _userAgent$match5[1]) || "Unknown";
    }
    return {
      browser: _browser,
      version: _version
    };
  }
}

var Popup = function Popup(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    beforeSubmit = _ref.beforeSubmit,
    uploadAttachmentsAPI = _ref.uploadAttachmentsAPI,
    feedbackAPI = _ref.feedbackAPI;
  var uploadedFilesTitleRef = useRef(null);
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    uploadedFiles = _useState2[0],
    setUploadedFiles = _useState2[1];
  var _useState3 = useState({
      feedbackType: "",
      summary: "",
      details: ""
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    formData = _useState4[0],
    setFormData = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    loading = _useState6[0],
    setLoading = _useState6[1];
  var _useState7 = useState({}),
    _useState8 = _slicedToArray(_useState7, 2),
    errors = _useState8[0],
    setErrors = _useState8[1];
  var _useState9 = useState(""),
    _useState10 = _slicedToArray(_useState9, 2),
    unexpectedError = _useState10[0],
    setUnexpectedError = _useState10[1];
  var _useState11 = useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    showThankYou = _useState12[0],
    setShowThankYou = _useState12[1];
  var _useState13 = useState(""),
    _useState14 = _slicedToArray(_useState13, 2),
    token = _useState14[0],
    setToken = _useState14[1];
  var _useState15 = useState(""),
    _useState16 = _slicedToArray(_useState15, 2),
    cohorts = _useState16[0],
    setCohorts = _useState16[1];
  var _useState17 = useState(""),
    _useState18 = _slicedToArray(_useState17, 2),
    userEmail = _useState18[0],
    setUserEmail = _useState18[1];
  var _useState19 = useState(""),
    _useState20 = _slicedToArray(_useState19, 2),
    paymentDetails = _useState20[0],
    setPaymentDetails = _useState20[1];
  var _useState21 = useState(""),
    _useState22 = _slicedToArray(_useState21, 2),
    programDetails = _useState22[0],
    setProgramDetails = _useState22[1];
  var _useState23 = useState(""),
    _useState24 = _slicedToArray(_useState23, 2),
    studentDetails = _useState24[0],
    setStudentDetails = _useState24[1];
  var _useState25 = useState(""),
    _useState26 = _slicedToArray(_useState25, 2),
    mockInterviewDetails = _useState26[0],
    setMockInterviewDetails = _useState26[1];
  useEffect(function () {
    var beforeSubmitData = beforeSubmit();
    setToken(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.token);
    setCohorts(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.cohorts);
    setUserEmail(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.user_email);
    setPaymentDetails(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.payment_data);
    setProgramDetails(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.program_data);
    setStudentDetails(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.student_data);
    setMockInterviewDetails(beforeSubmitData === null || beforeSubmitData === undefined ? undefined : beforeSubmitData.xpert_connect_data);
  }, [beforeSubmit]);
  var createAttachmentsPayload = function createAttachmentsPayload(uploadedFiles) {
    var attachmentPayload = {
      attachment_count: uploadedFiles.length,
      total_size: uploadedFiles.reduce(function (total, file) {
        return total + file.size;
      }, 0)
    };
    uploadedFiles.forEach(function (file, index) {
      attachmentPayload["attachment".concat(index + 1)] = {
        content_type: file.type,
        file_size: file.size,
        file_name: file.name.split('.').slice(0, -1).join('.')
      };
    });
    return attachmentPayload;
  };
  var handleSubmit = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(event) {
      var newErrors, mediaLinksArray, presignedResponse, locationData, _getBrowserInfo, browser, version, feedbackPayload;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            event.preventDefault();
            newErrors = {};
            if (!formData.feedbackType || formData.feedbackType === "Select feedback type") {
              newErrors.feedbackType = "Please select a valid feedback type.";
            }
            if (!formData.summary.trim()) {
              newErrors.summary = "This field must not be empty";
            } else if (formData.summary.length > 255) {
              newErrors.summary = "Summary cannot exceed 255 characters";
            }
            if (!formData.details.trim()) {
              newErrors.details = "This field must not be empty";
            } else if (formData.details.length > 10000) {
              newErrors.details = "Details cannot exceed 10000 characters";
            }
            setErrors(newErrors);
            if (!(Object.keys(newErrors).length === 0)) {
              _context.next = 46;
              break;
            }
            _context.prev = 7;
            setLoading(true); // Start loading
            mediaLinksArray = [];
            if (!(uploadedFiles.length > 0)) {
              _context.next = 25;
              break;
            }
            _context.prev = 11;
            _context.next = 14;
            return getPresignedURL(createAttachmentsPayload, uploadedFiles, uploadAttachmentsAPI, token);
          case 14:
            presignedResponse = _context.sent;
            _context.next = 17;
            return uploadFiles(uploadedFiles, presignedResponse, setUnexpectedError);
          case 17:
            mediaLinksArray = _context.sent;
            _context.next = 25;
            break;
          case 20:
            _context.prev = 20;
            _context.t0 = _context["catch"](11);
            console.error("Error during file upload:", _context.t0);
            setLoading(false);
            return _context.abrupt("return");
          case 25:
            _context.next = 27;
            return getLocationData(LOCATION_API);
          case 27:
            locationData = _context.sent;
            // Get browser and version
            _getBrowserInfo = getBrowserInfo(), browser = _getBrowserInfo.browser, version = _getBrowserInfo.version;
            feedbackPayload = {
              feedback_type: formData.feedbackType,
              title: formData.summary,
              description: formData.details,
              is_attachments: mediaLinksArray.length > 0,
              media_links: mediaLinksArray,
              os: navigator.userAgent,
              location: (locationData === null || locationData === undefined ? undefined : locationData.country) || "",
              city: (locationData === null || locationData === undefined ? undefined : locationData.city) || "",
              browser: browser,
              browser_version: version,
              datapoints: {
                visitor: userEmail,
                country_iso: (locationData === null || locationData === undefined ? undefined : locationData.country_code) || "",
                client: {
                  url: window.location.href,
                  screen_width: window.screen.width,
                  screen_height: window.screen.height
                },
                custom: {
                  cohort_details: cohorts,
                  payment_data: paymentDetails,
                  program_data: programDetails,
                  student_data: studentDetails,
                  xpert_connect_data: mockInterviewDetails
                }
              },
              ordered_inputs: [{
                0: {
                  field_type: "text",
                  field_id: "summary",
                  label: "A one line summary",
                  value: formData.summary
                },
                1: {
                  field_type: "textarea",
                  field_id: "details",
                  label: "A few more details",
                  value: formData.details
                }
              }]
            };
            _context.next = 32;
            return submitFeedback(feedbackPayload, feedbackAPI, token);
          case 32:
            _context.sent;
            setShowThankYou(true);
            resetForm(setFormData, setUploadedFiles, setErrors, setUnexpectedError);
            onClose(true);

            // Hide thank you message after 3 seconds
            setTimeout(function () {
              setShowThankYou(false);
            }, 3000);
            _context.next = 43;
            break;
          case 39:
            _context.prev = 39;
            _context.t1 = _context["catch"](7);
            console.error("Error while submitting feedback:", _context.t1);
            setUnexpectedError("We couldn't create your ticket. Please try again later or contact operations@interviewkickstart.com for help.");
          case 43:
            _context.prev = 43;
            setLoading(false); // Stop loading
            return _context.finish(43);
          case 46:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[7, 39, 43, 46], [11, 20]]);
    }));
    return function handleSubmit(_x) {
      return _ref2.apply(this, arguments);
    };
  }();
  var handleModalClose = function handleModalClose(onClose) {
    resetForm(setFormData, setUploadedFiles, setErrors, setUnexpectedError);
    onClose(true);
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, isOpen && /*#__PURE__*/React.createElement("div", {
    className: "ik-support"
  }, /*#__PURE__*/React.createElement("form", {
    onSubmit: function onSubmit(event) {
      return handleSubmit(event, formData, setErrors, uploadedFiles);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "support-tw-w-full support-tw-fixed support-tw-z-[1111] support-tw-inset-0 support-tw-justify-center support-tw-overflow-auto support-tw-bg-overlay support-tw-flex"
  }, /*#__PURE__*/React.createElement("div", {
    className: "support-tw-bg-white support-tw-max-h-modalMaxHeight support-tw-min-w-80 md:support-tw-min-w-100 md:support-tw-max-w-100 support-tw-rounded-md support-tw-flex support-tw-flex-col support-tw-overflow-auto support-tw-mt-auto support-tw-mb-auto"
  }, /*#__PURE__*/React.createElement("div", {
    className: "support-tw-p-4 md:support-tw-p-6 support-tw-border-b support-tw-rounded-t support-tw-relative support-tw-shadow-sm"
  }, loading && /*#__PURE__*/React.createElement("div", {
    className: "support-tw-absolute support-tw-left-[10px] support-tw-top-0 support-tw-h-[3px] support-tw-w-[50px] support-tw-bg-primary support-tw-animate-linemove"
  }), /*#__PURE__*/React.createElement("h3", {
    className: "support-tw-text-xl support-tw-font-bold support-tw-text-gray-900 support-tw-text-center"
  }, "How can we help you?"), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "support-tw-absolute support-tw-top-2 support-tw-right-2 support-tw-text-gray-400 support-tw-bg-transparent hover:support-tw-bg-gray-200 hover:support-tw-text-gray-900 support-tw-rounded-full support-tw-text-sm support-tw-w-6 support-tw-h-6 support-tw-inline-flex support-tw-justify-center support-tw-items-center",
    onClick: function onClick() {
      return handleModalClose(onClose);
    }
  }, /*#__PURE__*/React.createElement(CloseIcon, {
    className: "support-tw-w-2.5 support-tw-h-2.5 support-tw-text-[#212b37]"
  }), /*#__PURE__*/React.createElement("span", {
    className: "support-tw-sr-only"
  }, "Close modal"))), /*#__PURE__*/React.createElement("div", {
    className: "support-tw-p-4 md:support-tw-p-5 support-tw-space-y-4 support-tw-overflow-auto support-tw-flex-1"
  }, /*#__PURE__*/React.createElement(SelectInput, {
    value: formData.feedbackType,
    onChange: function onChange(event) {
      return handleChange(event, setFormData, setErrors);
    },
    error: errors.feedbackType
  }), /*#__PURE__*/React.createElement(TextInput, {
    id: "summary",
    label: "A one line summary",
    value: formData.summary,
    onChange: function onChange(event) {
      return handleChange(event, setFormData, setErrors);
    },
    error: errors.summary,
    maxLength: 255
  }), /*#__PURE__*/React.createElement(TextArea, {
    id: "details",
    label: "A few more details",
    value: formData.details,
    onChange: function onChange(event) {
      return handleChange(event, setFormData, setErrors);
    },
    error: errors.details,
    maxLength: 10000
  }), /*#__PURE__*/React.createElement(FileUpload, {
    uploadedFiles: uploadedFiles,
    handleFileUpload: function handleFileUpload$1(event) {
      return handleFileUpload(event, uploadedFiles, setUploadedFiles, setErrors, uploadedFilesTitleRef);
    },
    errors: errors.files,
    setUploadedFiles: setUploadedFiles,
    uploadedFilesTitleRef: uploadedFilesTitleRef
  })), /*#__PURE__*/React.createElement("div", {
    className: "support-tw-flex support-tw-flex-col support-tw-items-center support-tw-p-4 md:support-tw-p-4 support-tw-border-t support-tw-border-gray-200 support-tw-rounded-b"
  }, /*#__PURE__*/React.createElement("button", {
    type: "submit",
    disabled: loading,
    className: "support-tw-ml-auto support-tw-font-bold support-tw-rounded-sm support-tw-text-md support-tw-px-5 support-tw-py-2 support-tw-text-center support-tw-bg-primary support-tw-text-white focus:support-tw-outline-none ".concat(loading ? "support-tw-opacity-50 support-tw-cursor-not-allowed" : "")
  }, "Submit"), unexpectedError && /*#__PURE__*/React.createElement("p", {
    className: "support-tw-text-red-600 support-tw-text-small support-tw-mt-2 support-tw-text-center"
  }, unexpectedError)))))), showThankYou && /*#__PURE__*/React.createElement(SuccessPopup, {
    onClose: function onClose() {
      return setShowThankYou(false);
    }
  }));
};

// Store instances for multiple popups
var popupInstances = new Map();
var supportWidget = function supportWidget(_ref) {
  var target = _ref.target,
    _ref$options = _ref.options,
    options = _ref$options === undefined ? {} : _ref$options;
  var targetElement = typeof target === 'string' ? document.querySelector(target) : target;
  if (!targetElement) {
    console.error("Target element ".concat(target, " not found"));
    return;
  }
  var state = {
    isOpen: options.isOpen || false
  };

  // Store the instance data
  popupInstances.set(targetElement, {
    state: state
  });
  var controls = {
    open: function open() {
      state.isOpen = true;
      renderPopup();
    },
    close: function close() {
      state.isOpen = false;
      renderPopup();
    },
    toggle: function toggle() {
      state.isOpen = !state.isOpen;
      renderPopup();
    }
  };
  var renderPopup = function renderPopup() {
    ReactDOM.render(/*#__PURE__*/React.createElement(Popup, _objectSpread2(_objectSpread2({}, options), {}, {
      isOpen: state.isOpen,
      onClose: controls.close
    })), targetElement);
  };
  renderPopup();
  return controls;
};
if (typeof window !== 'undefined') {
  window.PopupTool = {
    supportWidget: supportWidget
  };
}

export { Popup, supportWidget };
